;From Inbar Raz
;The first  - KEYSWAP.ASM replaces a keystroke with another.
;The second - KEYDISP, is an accessory in order for you to determine the values
;             that AX received for various keystrokes, so you can alter KEYSWAP
;             to your like.

KEYSWAP.ASM

        model   tiny
        .code

        org     0100h

Start:  jmp     Begin

Old16h  dd      ?

TRIGGER         EQU     02B7Ch          ; '|'
REPLACEMENT     EQU     0273Bh          ; ';'

New16h  Proc    Far

        ; Installation Check?

        cmp     ax,'KE'
        jne     NotCheck
        cmp     bx,'Y?'
        jne     NotCheck

        ; Yes it is

        mov     ax,'SW'
        mov     bx,'AP'

        iret

NotCheck:

        or      ah,ah           ; Get keystroke?
        je      CorrectFunction

        ; This is not even the function that we are monitoring, let's exit.

        jmp     dword ptr cs:[Old16h]

CorrectFunction:

        ; Call the original function, and see what key it is

        pushf
        call    dword ptr cs:[Old16h]

        ; Is this our trigger key?

        cmp     ax,TRIGGER
        jne     BadKey

        mov     ax,REPLACEMENT

BadKey:
        ; We are done, exit.

        iret

New16h  Endp

EndOfResidentCode       EQU     $

msgCopyright    db      'KeySwap 1.0, by Inbar Raz. Released to the public '
                db      'domain.', 00Dh, 00Ah, 24h
msgAlready      db      'Already installed!', 00Dh, 00Ah, 24h
msgInstall      db      'Successfully installed!', 00Dh, 00Ah, 24h

Begin:
        ; Copyright notice ('no copyright' notice, actually...)

        mov     ah,09h
        mov     dx,offset msgCopyright
        int     021h

        ; Installation Check

        mov     ax,'KE'
        mov     bx,'Y?'
        int     016h

        cmp     ax,'SW'
        jne     Install
        cmp     bx,'AP'
        jne     Install

        ; We are already installed

        mov     ah,09h
        mov     dx,offset msgAlready
        int     021h

        mov     ah,04Ch
        int     021h

Install:
        ; Announce the installation

        mov     ah,09h
        mov     dx,offset msgInstall
        int     021h

        mov     ax,03516h
        int     021h

        mov     word ptr [Old16h],bx
        mov     word ptr [Old16h+2],es

        mov     ax,02516h
        mov     dx,offset New16h
        int     021h

        ; Stay resident

        mov     dx,offset EndOfResidentCode
        int     27h

        end     Start

---------------------------------= cut here =---------------------------------

KEYDISP.ASM

        model   tiny
        .code

        org     0100h

TRIGGER         EQU     02E03h      ; ^C

Start:  mov     ah,09h
        mov     dx,offset msgCopyright
        int     021h

KeyLoop:

        xor     ah,ah
        int     016h

        cmp     ax,TRIGGER
        je      Done

        mov     bx,ax
        call    Display

        mov     ah,09h
        mov     dx,offset msgCRLF
        int     021h

        jmp     KeyLoop

Done:   mov     ah,04Ch
        int     021h

Display Proc    Near

        mov     ch,4
rotate: mov     cl,4
        rol     bx,cl
        mov     al,bl
        and     al,0fh
        add     al,30h
        cmp     al,3ah
        jl      printit
        add     al,7h
printit:
        mov     dl,al
        mov     ah,02
        int     21h
        dec     ch
        jnz     rotate

        ret

Display Endp

msgCopyright    db      'KeyDisp - Accessory to KeySwap: Display Int16 '
                db      'KeyCodes. ', 00Dh, 00Ah
                db      'By Inbar Raz, released to the public domain. '
                db      'Press ^C to exit.'
msgCRLF         db      00Dh, 00Ah, 24h

        end     Start

