comment %

    A quick and dirty spawn program example for OS/2 VDM DOS sessions
    Written by Mikko Hyvarinen, 8. Dec 1995.

    Spawns the DOS command processor in an independent session
    Works also under TShell, the nit-picky text-mode OS/2 shell

    Got the API info from Ralf Brown's Interrupt List #47
    Thanks Ralf, keep up the good work!

    Placed to the public domain by the author. Do whatever you want with
    this code. The author is not responsible for any damages this program
    might cause, use at your own risk.

    Comments, suggestions, corrections and other information about OS/2
    and OS/2 VDM programming welcome in address 2:229/229.5 (fidonet)

%

.386
jumps
locals      ; These lines maybe superfluous, but it's become a habit ;)

cseg segment para use16 public 'code'
assume cs:cseg, ds:cseg, ss:cseg

org 100h    ; We're going to make a .COM file out of this

main:
    push cs
    pop ds
    mov word ptr [start_title], offset pgm_title
    mov word ptr [start_title+2], ds
; Uncomment these if you want to test this with an actual program
;    mov word ptr [start_program], offset pgm_name
;    mov word ptr [start_program+2], ds
;    mov word ptr [start_args], offset pgm_args
;    mov word ptr [start_args+2], ds
    mov si, offset start_buffer     ; DS:SI = pointer to info buffer
    mov ax, 6400h           ; OS/2 function request
    mov bx, 0025h           ; OS/2 API ordinal, 25h = DOS32StartSession
    mov cx, 636ch           ; Magic number, must be set!
    int 21h                 ; Do the thingy
    mov ah, 4ch             ; Preserve DOS32StartSession return code in AL
    int 21h                 ; Terminate with return code

start_buffer label word
    dw  20h                 ; Buffer length. Must be 18h/1eh/20h under TShell
                            ; Otherwise can be also 32h or 3Ch
    dw  0                   ; 0 = Independent, 1 = Child
    dw  0                   ; 0 = Foreground, 1 = BackGround
    dw  0                   ; Trace option (0-2), 0 = no trace (what is this?)
start_title label word
    dw  0                   ; Offset of ASCIIZ program title (max. 62 chars)
    dw  0                   ; Segment ... (these 2 items can be zero)
start_program label word
    dw  0                   ; Offset of ASCIIZ program name (max. 128 chars)
    dw  0                   ; Segment ... (these 2 items can be zero)
start_args label word
    dw  0                   ; Offset of ASCIIZ program arguments (max. 144)
    dw  0                   ; Segment ... (these 2 items can be zero)

    dd  0                   ; Reserved, must be 0
    dd  0                   ; Pointer environment
    dw  0                   ; Inheritance, 0 or 1 (dunno what this is)
    dw  4                   ; Type:
                            ;  0 = OS/2 session manager determines type
                            ;  1 = OS/2 full screen
                            ;  2 = OS/2 windowed
                            ;  3 = PM
                            ;  4 = VDM full-screen
                            ;  7 = VDM windowed
; Items after this point are not available under TShell
    dd  0                   ; Pointer to ASCIIZ icon filename
    dd  0                   ; PgmHandle, currently reserved, must be 0
    dw  0                   ; PgmControl (dunno about this)
    dw  0                   ; Initial column
    dw  0                   ; Initial row
    dw  0                   ; Initial width
    dw  0                   ; Initial height
    dw  0                   ; Reserved, must be 0
    dd  0                   ; ObjectBuffer, currently reserved (?), must be 0
    dd  0                   ; ObjectBufferLen, ------------- " ----------

pgm_title   db  'Yeah! This works!', 0
pgm_name    db  'We could actually put something in here', 0
pgm_args    db  'This is where the arguments are placed', 0

cseg ends

end main
